  /********* Begin Procedure Script ************/
 BEGIN


 	DECLARE var_cur_time time = CURRENT_TIME;
 	DECLARE var_cur_date date = CURRENT_DATE;
 	DECLARE var_cur_date_time TIMESTAMP = CURRENT_TIMESTAMP;

    /** RESRCE INFO **/

 	var_resource=SELECT
 	A.SITE,
 	A.HANDLE,
 	A.WORK_AREA,
 	A.LINE_AREA,
 	A.RESRCE,
 	B.RESOURCE_TYPE,
 	A.DESCRIPTION AS RESRCE_NAME
	FROM MHP_OEE.RESRCE AS A,MHP_OEE.RESOURCE_TYPE AS B,MHP_OEE.RESOURCE_TYPE_RESOURCE AS C
	WHERE A.HANDLE=C.RESOURCE_BO AND B.HANDLE=C.RESOURCE_TYPE_BO
	AND A.SITE = :site_in
	AND B.ENABLED = 'true'
	AND A.CONFIGURED_PLC_INFO = 'true';


	/**FILTER LINE **/
 	/**var_resource = APPLY_FILTER(:var_resource, :line_in);**/
 	/**FILTER RESOURCE_TYPE **/
 	/**var_resource = APPLY_FILTER(:var_resource, :resource_type_in);**/
	/**FILTER RESRCE **/
	var_resource = APPLY_FILTER(:var_resource, :work_area_in);
 	var_resource = APPLY_FILTER(:var_resource, :resrce_in);
 	var_resource = APPLY_FILTER(:var_resource, :line_in);
 	var_resource = APPLY_FILTER(:var_resource, :resource_type_in);


	var_date_range_b = SELECT HANDLE, WORK_CENTER
	FROM MHP_OEE.WORK_CENTER;

	var_date_range_b = APPLY_FILTER(:var_date_range_b, :work_center_in);


 	/**获取班次开始和结束时间**/
    var_date_range=SELECT
    A.START_TIME,
    A.END_TIME,
 	A.WORK_CENTER_BO,
 	1 as QTY
 	FROM MHP_OEE.WORK_CENTER_SHIFT AS A
 	INNER JOIN :var_date_range_b AS B ON A.WORK_CENTER_BO=B.HANDLE
 	WHERE (A.START_TIME < :var_cur_time  AND  :var_cur_time < A.END_TIME
	OR
	(A.START_TIME < :var_cur_time OR  :var_cur_time < A.END_TIME) AND A.START_TIME > A.END_TIME);


 	/** RESRCE SHIFT INFO **/
	var_resrce_shift = SELECT
	A.SITE,
 	A.HANDLE,
 	A.WORK_AREA,
 	A.LINE_AREA,
 	A.RESRCE,
 	A.RESRCE_NAME,
 	B.DESCRIPTION AS WORK_AREA_DES,
 	C.WORK_CENTER_BO
	FROM :var_resource AS A
	LEFT JOIN MHP_OEE.WORK_CENTER AS B
	ON A.SITE = B.SITE AND A.WORK_AREA = B.WORK_CENTER
	LEFT JOIN MHP_OEE.WORK_CENTER_SHIFT AS C
	ON B.HANDLE = C.WORK_CENTER_BO
	WHERE B.ENABLED='true'
	AND C.ENABLED='true'
	GROUP BY A.SITE, A.HANDLE, A.WORK_AREA, A.LINE_AREA, A.RESRCE, A.RESRCE_NAME,B.DESCRIPTION,C.WORK_CENTER_BO;


 	var_add_shift_time=SELECT
	A.SITE,
 	A.HANDLE,
 	A.WORK_AREA,
 	A.LINE_AREA,
 	A.RESRCE,
 	A.RESRCE_NAME,
 	A.WORK_AREA_DES,
 	A.WORK_CENTER_BO,
 	B.START_TIME,
 	B.END_TIME
 	FROM :var_resrce_shift AS A
 	INNER JOIN :var_date_range AS B ON A.WORK_CENTER_BO=B.WORK_CENTER_BO;


 	var_add_shift_date=SELECT
	A.SITE,
 	A.HANDLE,
 	A.WORK_AREA,
 	A.LINE_AREA,
 	A.RESRCE,
 	A.RESRCE_NAME,
 	A.WORK_AREA_DES,
 	A.WORK_CENTER_BO,
 	A.START_TIME,
 	CASE WHEN :var_cur_time<A.END_TIME AND A.START_TIME>A.END_TIME
 		THEN CAST(CAST(ADD_DAYS(:var_cur_date,-1) AS NVARCHAR) || ' ' || CAST(START_TIME AS NVARCHAR) AS SECONDDATE)
 		ELSE
 		CAST(CAST(:var_cur_date AS NVARCHAR) || ' ' || CAST(START_TIME AS NVARCHAR) AS SECONDDATE)
 		END AS DATE_TIME,
 	CASE WHEN :var_cur_time>A.START_TIME AND A.START_TIME>A.END_TIME
 		THEN
 		CAST(CAST(ADD_DAYS(:var_cur_date,1) AS NVARCHAR) || ' ' || CAST(END_TIME AS NVARCHAR) AS SECONDDATE)
 		ELSE
 		CAST(CAST(:var_cur_date AS NVARCHAR) || ' ' || CAST(END_TIME AS NVARCHAR) AS SECONDDATE)
 		END AS END_DATE
 	FROM :var_add_shift_time AS A;



	/** 设备取拉线描述  **/
	var_resrce_line_desc = SELECT
	A.SITE,
 	A.HANDLE,
 	A.WORK_AREA,
 	A.LINE_AREA,
 	A.RESRCE,
 	A.RESRCE_NAME,
 	A.WORK_AREA_DES,
 	A.START_TIME,
 	A.DATE_TIME,
 	B.DESCRIPTION AS LINE_AREA_DES
 	FROM :var_add_shift_date AS A
 	LEFT JOIN MHP_OEE.WORK_CENTER AS B
 	ON  A.SITE = B.SITE
 	AND A.LINE_AREA = B.WORK_CENTER
 	WHERE B.ENABLED = 'true';


	/**设备 关联设备log  可能会关联到多条log**/
 	var_resource_time_log=SELECT
 	A.SITE,
 	A.HANDLE,
 	A.WORK_AREA,
 	A.LINE_AREA,
 	A.RESRCE,
 	A.RESRCE_NAME,
 	A.DATE_TIME,
	A.LINE_AREA_DES,
	A.WORK_AREA_DES,
	B.RESOURCE_STATE,
	B.START_DATE_TIME,
	--B.END_DATE_TIME,
	row_number() over(PARTITION BY A.HANDLE ORDER BY B.START_DATE_TIME DESC) AS ORDER_QTY
 	FROM :var_resrce_line_desc AS A
 	LEFT JOIN MHP_OEE.RESOURCE_TIME_LOG AS B
 	ON A.SITE=B.SITE
 	AND A.HANDLE=B.RESOURCE_BO
 	AND B.START_DATE_TIME <= :var_cur_date_time
 	AND B.END_DATE_TIME IS NULL;

 	/**设备 关联设备log 得最大一条的log**/
 	var_resource_log_filter=SELECT
 	SITE,
 	HANDLE,
 	WORK_AREA,
 	LINE_AREA,
 	RESRCE,
 	RESRCE_NAME,
 	DATE_TIME,
	LINE_AREA_DES,
	WORK_AREA_DES,
	START_DATE_TIME,
	--END_DATE_TIME,
	RESOURCE_STATE
	FROM :var_resource_time_log
 	WHERE ORDER_QTY = 1;

	/**设备 关联设备状态**/
 	var_resource_state_before=SELECT
 	A.SITE,
 	A.HANDLE,
 	A.WORK_AREA,
 	A.LINE_AREA,
 	A.RESRCE,
 	A.RESRCE_NAME,
 	A.DATE_TIME,
	A.LINE_AREA_DES,
	A.WORK_AREA_DES,
	A.START_DATE_TIME,
	--A.END_DATE_TIME,
	B.DESCRIPTION AS RESOURCE_STATE_DES,
	B.STATE AS RESOURCE_STATE
 	FROM :var_resource_log_filter AS A
 	LEFT JOIN MHP_OEE.RESOURCE_STATE AS B
 	ON A.RESOURCE_STATE=B.STATE
 	AND A.SITE=B.SITE;

    var_resource_state_d=SELECT * FROM :var_resource_state_before WHERE RESOURCE_STATE='D';
 	var_resource_state_fd=SELECT * FROM :var_resource_state_before WHERE RESOURCE_STATE<>'D' or RESOURCE_STATE is null;
 	var_resource_state_a = SELECT
 	A.SITE,
 	A.HANDLE,
 	A.WORK_AREA,
 	A.LINE_AREA,
 	A.RESRCE,
 	A.RESRCE_NAME,
 	A.DATE_TIME,
	A.LINE_AREA_DES,
	A.WORK_AREA_DES,
	--A.RESOURCE_STATE_DES,
	A.RESOURCE_STATE,
	CASE WHEN R.DESCRIPTION IS NOT NULL
		 THEN R.DESCRIPTION ELSE A.RESOURCE_STATE_DES
	 			END  AS RESOURCE_STATE_DES,
	B.DATE_TIME AS DATE_TIME_PRESS
	FROM :var_resource_state_d AS A
	LEFT JOIN MHP_OEE.RESOURCE_REASON_LOG AS B
	ON B.ACTION_CODE='START' AND B.RESRCE = A.RESRCE
	   AND B.DATE_TIME >= A.START_DATE_TIME
	LEFT JOIN MHP_OEE.REASON_CODE AS R
	ON B.REASON_CODE=R.REASON_CODE;


	var_resource_state_tj = SELECT * FROM :var_resource_state_a WHERE RESOURCE_STATE_DES='停机';
	var_resource_state_b = SELECT
 	SITE,
 	HANDLE,
 	WORK_AREA,
 	LINE_AREA,
 	RESRCE,
 	RESRCE_NAME,
 	DATE_TIME,
	LINE_AREA_DES,
	WORK_AREA_DES,
	RESOURCE_STATE,
	RESOURCE_STATE_DES,
	DATE_TIME_PRESS,
	ROW_NUMBER() OVER(PARTITION BY  SITE,
								 	HANDLE,
								 	WORK_AREA,
								 	LINE_AREA,
								 	RESRCE,
								 	RESRCE_NAME,
								 	DATE_TIME,
									LINE_AREA_DES,
									WORK_AREA_DES,
									RESOURCE_STATE
										ORDER BY DATE_TIME_PRESS DESC) AS R_NUM
			FROM :var_resource_state_a
			where RESOURCE_STATE_DES <> '停机';

	var_resource_state = SELECT
							SITE,
						 	HANDLE,
						 	WORK_AREA,
						 	LINE_AREA,
						 	RESRCE,
						 	RESRCE_NAME,
						 	DATE_TIME,
							LINE_AREA_DES,
							WORK_AREA_DES,
							RESOURCE_STATE,
							RESOURCE_STATE_DES FROM :var_resource_state_b WHERE R_NUM=1
							UNION ALL
							SELECT
							SITE,
						 	HANDLE,
						 	WORK_AREA,
						 	LINE_AREA,
						 	RESRCE,
						 	RESRCE_NAME,
						 	DATE_TIME,
							LINE_AREA_DES,
							WORK_AREA_DES,
							RESOURCE_STATE,
							RESOURCE_STATE_DES FROM :var_resource_state_fd
							UNION All
							SELECT
							SITE,
						 	HANDLE,
						 	WORK_AREA,
						 	LINE_AREA,
						 	RESRCE,
						 	RESRCE_NAME,
						 	DATE_TIME,
							LINE_AREA_DES,
							WORK_AREA_DES,
							RESOURCE_STATE,
							RESOURCE_STATE_DES FROM :var_resource_state_tj;







 	/**设备 关联PPM **/
 	var_resource_ppm = SELECT
 	A.SITE,
 	A.HANDLE,
 	A.WORK_AREA,
 	A.LINE_AREA,
 	A.RESRCE,
 	A.RESRCE_NAME,
 	A.DATE_TIME,
	A.LINE_AREA_DES,
	A.WORK_AREA_DES,
	A.RESOURCE_STATE_DES,
	A.RESOURCE_STATE,
	B.REALTIME_PPM
 	FROM :var_resource_state AS A
 	LEFT JOIN MHP_OEE.REALTIME_PPM AS B
 	ON A.HANDLE = B.RESOURCE_BO;

 	/**设备 关联三色灯 **/
 	var_color=SELECT
 	A.SITE,
 	A.HANDLE,
 	A.WORK_AREA,
 	A.LINE_AREA,
 	A.RESRCE,
 	A.RESRCE_NAME,
 	A.DATE_TIME,
	A.LINE_AREA_DES,
	A.WORK_AREA_DES,
	A.RESOURCE_STATE_DES,
	A.RESOURCE_STATE,
	A.REALTIME_PPM,
	B.COLOR_LIGHT
 	FROM :var_resource_ppm AS A
 	LEFT JOIN MHP_OEE.COLOR_LIGHT AS B
 	ON A.HANDLE=B.RESOURCE_BO;

 	/** RESOURCE_ALERT_LOG 录取当日累计报警次数 **/
 	var_resource_alert_handle_count=SELECT
 	A.HANDLE,
 	COUNT(A.HANDLE) AS ALERT_COUNT
 	FROM :var_color AS A
 	INNER JOIN MHP_OEE.RESOURCE_ALERT_LOG AS B
 	ON  A.SITE=B.SITE
 	AND A.RESRCE=B.RESRCE
 	AND B.DATE_TIME >= A.DATE_TIME
 	AND B.DATE_TIME<= :var_cur_date_time
 	GROUP BY A.HANDLE;

 	/** RESRCE 关联  录取当日累计报警次数 **/
 	var_resource_alert_log=SELECT
 	A.SITE,
 	A.HANDLE,
 	A.WORK_AREA,
 	A.LINE_AREA,
 	A.RESRCE,
 	A.RESRCE_NAME,
 	A.DATE_TIME,
	A.LINE_AREA_DES,
	A.WORK_AREA_DES,
	A.RESOURCE_STATE_DES,
	A.RESOURCE_STATE,
	A.REALTIME_PPM,
	A.COLOR_LIGHT,
 	CASE WHEN B.ALERT_COUNT IS NULL THEN 0 ELSE B.ALERT_COUNT END AS ALERT_COUNT
 	FROM :var_color AS A
 	LEFT JOIN :var_resource_alert_handle_count AS B
 	ON A.HANDLE = B.HANDLE;

 	/**RESOURCE_TIME_LOG 录取当日累计停机次数**/
 	var_down_count=SELECT
 	A.HANDLE,
 	COUNT(B.HANDLE) AS HALT_COUNT
 	FROM :var_resource_alert_log AS A
 	INNER JOIN MHP_OEE.RESOURCE_TIME_LOG AS B
 	ON A.SITE=B.SITE
 	AND A.HANDLE=B.RESOURCE_BO
 	AND B.RESOURCE_STATE='D'
 	AND(
 	(B.START_DATE_TIME<=A.DATE_TIME AND B.END_DATE_TIME>A.DATE_TIME AND B.END_DATE_TIME <= :var_cur_date_time)
 	OR (B.START_DATE_TIME<=A.DATE_TIME AND (B.END_DATE_TIME IS NULL OR B.END_DATE_TIME = '') )
 	OR (B.START_DATE_TIME >= A.DATE_TIME and B.END_DATE_TIME <= :var_cur_date_time)
 	OR (B.START_DATE_TIME >= A.DATE_TIME and (B.END_DATE_TIME IS NULL OR B.END_DATE_TIME = ''))
 	)
 	WHERE
		B.END_DATE_TIME is not null
		or B.HANDLE  in(
			select HANDLE from(
				select  HANDLE,ROW_NUMBER() over(partition by rtl.RESOURCE_BO order by rtl.START_DATE_TIME desc) as num
				from MHP_OEE.RESOURCE_TIME_LOG rtl
				where rtl.END_DATE_TIME is null
				) a where a.num = 1
		)
 	GROUP BY A.HANDLE;

 	/**RESRCE 关联当日累计停机次数**/
 	var_down=SELECT
 	A.SITE,
 	A.HANDLE,
 	A.WORK_AREA,
 	A.LINE_AREA,
 	A.RESRCE,
 	A.RESRCE_NAME,
 	A.DATE_TIME,
	A.LINE_AREA_DES,
	A.WORK_AREA_DES,
	A.RESOURCE_STATE_DES,
	A.RESOURCE_STATE,
	A.REALTIME_PPM,
	A.COLOR_LIGHT,
 	A.ALERT_COUNT,
 	CASE WHEN B.HALT_COUNT IS NULL THEN 0 ELSE B.HALT_COUNT END AS HALT_COUNT
 	FROM :var_resource_alert_log AS A
 	LEFT JOIN :var_down_count AS B
 	ON A.HANDLE = B.HANDLE;

 	var_output = SELECT
 	A.SITE,
 	A.HANDLE,
 	A.WORK_AREA,
 	A.LINE_AREA,
 	A.RESRCE,
 	A.RESRCE_NAME,
	A.LINE_AREA_DES,
	A.WORK_AREA_DES,
	---A.RESOURCE_STATE_DES as RESOURCE_STATE,
	CASE WHEN A.RESOURCE_STATE_DES IS NULL THEN '' ELSE A.RESOURCE_STATE_DES END AS RESOURCE_STATE,
	--A.REALTIME_PPM,
	CASE WHEN A.REALTIME_PPM IS NULL THEN '' ELSE ROUND(A.REALTIME_PPM,2) || '' END AS REALTIME_PPM,
	A.COLOR_LIGHT,
 	A.ALERT_COUNT,
 	A.HALT_COUNT,
 	A.DATE_TIME
 	FROM :var_down AS A;


 	var_out_qty_total = SELECT
 	SUM(QTY_TOTAL) AS QTY_TOTAL,
 	A.RESRCE
 	FROM :var_output AS A
 	LEFT JOIN MHP_OEE.PRODUCTION_OUTPUT_REALTIME AS B
 	ON B.SITE = A.SITE and
	B.RESRCE = A.RESRCE and
	B.START_DATE_TIME >= A.DATE_TIME and
	B.START_DATE_TIME <= :var_cur_date_time
	GROUP BY A.RESRCE;


	var_out_before = SELECT
 	A.SITE,
 	A.HANDLE,
 	A.WORK_AREA,
 	A.LINE_AREA,
 	A.RESRCE,
 	A.RESRCE_NAME,
	A.LINE_AREA_DES,
	A.WORK_AREA_DES,
	CASE WHEN A.RESOURCE_STATE='停机'
	     THEN '待PRD处理'
	     ELSE A.RESOURCE_STATE
	     END AS RESOURCE_STATE,
	A.REALTIME_PPM,
	A.COLOR_LIGHT,
 	A.ALERT_COUNT,
 	A.HALT_COUNT,
 	1 AS QTY,
 	A.DATE_TIME,
 	B.QTY_TOTAL,
 	CASE WHEN A.COLOR_LIGHT='R' THEN 'A'
	WHEN A.COLOR_LIGHT='Y' THEN 'B'
	WHEN A.COLOR_LIGHT='G' THEN 'C'
	ELSE 'D' END AS ORDER_FIELD
 	FROM :var_output AS A
 	LEFT JOIN :var_out_qty_total AS B
 	ON B.RESRCE = A.RESRCE;

 	var_out_x = SELECT
 	A.SITE,
 	A.HANDLE,
 	A.WORK_AREA,
 	A.LINE_AREA,
 	A.RESRCE,
 	A.RESRCE_NAME,
	A.LINE_AREA_DES,
	A.WORK_AREA_DES,
	CASE WHEN A.RESOURCE_STATE=''
	     THEN '待PRD处理'
	     ELSE A.RESOURCE_STATE
	     END AS RESOURCE_STATE,
	A.REALTIME_PPM,
	A.COLOR_LIGHT,
 	A.ALERT_COUNT,
 	A.HALT_COUNT,
 	A.QTY,
 	A.DATE_TIME,
 	A.QTY_TOTAL,
 	A.ORDER_FIELD,
 	POR.START_DATE_TIME
 	FROM :var_out_before AS A
 	LEFT JOIN (SELECT MAX(PR.START_DATE_TIME)AS START_DATE_TIME ,PR.SITE,PR.RESRCE
 					FROM MHP_OEE.PRODUCTION_OUTPUT_REALTIME AS PR
 					GROUP BY PR.SITE,PR.RESRCE) AS POR
 	       ON A.SITE=POR.SITE AND A.RESRCE=POR.RESRCE ;


 	var_out_y = SELECT
 	A.SITE,
 	A.HANDLE,
 	A.WORK_AREA,
 	A.LINE_AREA,
 	A.RESRCE,
 	A.RESRCE_NAME,
	A.LINE_AREA_DES,
	A.WORK_AREA_DES,
	A.RESOURCE_STATE,
	A.REALTIME_PPM,
	A.COLOR_LIGHT,
 	A.ALERT_COUNT,
 	A.HALT_COUNT,
 	A.QTY,
 	A.DATE_TIME,
 	A.QTY_TOTAL,
 	A.ORDER_FIELD,
 	POR.ITEM
 	FROM :var_out_x AS A
 	LEFT JOIN MHP_OEE.PRODUCTION_OUTPUT_REALTIME AS POR
 	       ON A.SITE=POR.SITE AND A.RESRCE=POR.RESRCE
 	       AND A.START_DATE_TIME=POR.START_DATE_TIME;


 	var_out_z = SELECT
 	A.SITE,
 	A.HANDLE,
 	A.WORK_AREA,
 	A.LINE_AREA,
 	A.RESRCE,
 	A.RESRCE_NAME,
	A.LINE_AREA_DES,
	A.WORK_AREA_DES,
	A.RESOURCE_STATE,
	A.REALTIME_PPM,
	A.COLOR_LIGHT,
 	A.ALERT_COUNT,
 	A.HALT_COUNT,
 	A.QTY,
 	A.DATE_TIME,
 	A.QTY_TOTAL,
 	A.ORDER_FIELD,
 	A.ITEM,
 	B.END_DATE_TIME
 	FROM :var_out_y AS A
 	LEFT JOIN ( SELECT MAX(RTL.END_DATE_TIME) AS END_DATE_TIME,RTL.SITE,RTL.RESOURCE_BO
 				FROM MHP_OEE.RESOURCE_TIME_LOG RTL WHERE RTL.RESOURCE_STATE='P'
 				GROUP BY RTL.SITE,RTL.RESOURCE_BO) AS B
 			ON A.SITE=B.SITE AND A.HANDLE=B.RESOURCE_BO ;


 	var_out_s = SELECT
 	A.SITE,
 	A.HANDLE,
 	A.WORK_AREA,
 	A.LINE_AREA,
 	A.RESRCE,
 	A.RESRCE_NAME,
	A.LINE_AREA_DES,
	A.WORK_AREA_DES,
	A.RESOURCE_STATE,
	A.REALTIME_PPM,
	A.COLOR_LIGHT,
 	A.ALERT_COUNT,
 	A.HALT_COUNT,
 	A.QTY,
 	A.DATE_TIME,
 	A.QTY_TOTAL,
 	A.ORDER_FIELD,
 	A.ITEM,
 	B.DATE_TIME AS ALERT_TIME,
 	CASE WHEN A.COLOR_LIGHT='G' THEN '' ELSE B.DESCRIPTION END AS DESCRIPTION
 	FROM :var_out_z AS A
 	LEFT JOIN MHP_OEE.RESOURCE_ALERT_LOG AS B
 	ON A.SITE = B.SITE AND A.RESRCE = B.RESRCE
 	AND B.DATE_TIME>=ADD_SECONDS(A.END_DATE_TIME,-5)
 	AND B.DATE_TIME<=ADD_SECONDS(A.END_DATE_TIME,5);

 	var_out = SELECT
 	A.SITE,
 	A.HANDLE,
 	A.WORK_AREA,
 	A.LINE_AREA,
 	A.RESRCE,
 	A.RESRCE_NAME,
	A.LINE_AREA_DES,
	A.WORK_AREA_DES,
	A.RESOURCE_STATE,
	A.REALTIME_PPM,
	A.COLOR_LIGHT,
 	A.ALERT_COUNT,
 	A.HALT_COUNT,
 	A.QTY,
 	A.DATE_TIME,
 	A.QTY_TOTAL,
 	A.ORDER_FIELD,
 	A.ITEM,
 	A.ALERT_TIME,
 	CASE WHEN A.DESCRIPTION IS NULL THEN '' ELSE A.DESCRIPTION END AS DESCRIPTION
 	FROM :var_out_s AS A;
END /********* End Procedure Script ************/